%Inputs: model, Sparse feature code X, Labels Y, Distribution D
%Outputs: Hypotheis h, error of hypothesis werr, model

%Author: Naveen Kulkarni
%Group: Visual Processing and Representation Group, ASU
%October 11 2010
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [h, werr,model] = svm_train_test(model, X, Y, D)

%  model = svmtrain(Y(idx),X(idx,:),'-s 0 -c 1 -t 0');
if 1
if isempty(model)
    m = length(Y);
    randSeed = RandStream.create('mrg32k3a','seed',1);
    idx = randp(D,randSeed,m,1);
    c = 10;
    options = ['-c ' num2str(c)];
    model = train(double(Y(idx)), sparse(X(idx,:)), options);
end
end
if 0
    c = 10;
    options = ['-c ' num2str(c)];
    model = train(double(Y), sparse(X), options);
end
%  h = svmpredict(Y, X, model);
% [h] = predict(test_label', sparse(test_fea), model);
 
%  werr = [];
%     if ~isempty(D)
%         werr = sum(D1(h ~= test_label')); % Should direction be taken into account? I guess not.
%     end
 [h] = predict(Y, sparse(X), model);   
 werr = [];
    if ~isempty(D)
        if  1
        werr = sum(D(h ~= Y)); % Should direction be taken into account? I guess not.
        end
%         werr = sum((h ~= Y)); % Should direction be taken into account? I guess not.
    end